﻿import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/settings/popup_settings.ini")

modules = ["match", "scoreboard", "skins"]

# ******************** Load ********************
def load():
	es.keygroupload("soccer_mod_settings", "soccer_mod")

	create_popup()

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			es.load("soccer_mod_2011/admin/settings/%s" % (item))

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_settings")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	number = 0

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			number += 1
			popup.addline("->%s. %s" % (number, popup_text(item)))
			popup.submenu(number, "sm_popup_admin_settings_%s" % (item))

	if number == 0:
		popup.addline(popup_text("none"))

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(number + 1, 9):
		popup.submenu(i, "sm_popup_admin_settings")

	popup.submenu(9, "sm_popup_admin")

# ******************** Functions ********************
def set_boolean(userid, file, module, setting, name, number):
	messages = langlib.Strings("%sadmin/settings/messages_settings_%s.ini" % (lang_dir, file))
	texts = langlib.Strings("%sadmin/settings/popup_settings_%s.ini" % (lang_dir, file))

	tokens = {}
	tokens["name"] = es.getplayername(userid)

	cvar = "sm_%s_%s_on" % (module, setting)
	if es.ServerVar(cvar) == 1:
		es.set(cvar, 0)
		es.keysetvalue("soccer_mod_settings", module, setting, 0)

		popuplib.find(name).modline((number + 2), "->%s. %s: %s" % (number, texts(setting), messages_common("off")))

		lang_msg_boolean(messages, "set_%s" % (setting), tokens, "off")
	else:
		es.set(cvar, 1)
		es.keysetvalue("soccer_mod_settings", module, setting, 1)

		popuplib.find(name).modline((number + 2), "->%s. %s: %s" % (number, texts(setting), messages_common("on")))

		lang_msg_boolean(messages, "set_%s" % (setting), tokens, "on")

	es.keygroupsave("soccer_mod_settings", "soccer_mod")

	popuplib.send(name, userid)

def lang_msg_boolean(messages, text, tokens, on_off):
	for player in playerlib.getPlayerList("#human"):
		tokens["value"] = messages_common(on_off, tokens, player.get("lang"))
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

def set_number(userid, text, file, module, setting, decimals, min, max, name, number):
	messages = langlib.Strings("%sadmin/settings/messages_settings_%s.ini" % (lang_dir, file))
	texts = langlib.Strings("%sadmin/settings/popup_settings_%s.ini" % (lang_dir, file))

	tokens = {}
	player = playerlib.getPlayer(userid)

	text = text.strip('"')

	if text != "!cancel":
		error = messages("type_%s" % (setting), tokens, player.get("lang"))
		try:
			if decimals == 0:
				value = int(round(float(text), 0))
			else:
				value = round(float(text), decimals)

			if value >= min:
				if value <= max:
					es.set("sm_%s_%s" % (module, setting), value)

					popuplib.find(name).modline((number + 2), "->%s. %s: %s" % (number, texts(setting), value))

					es.keysetvalue("soccer_mod_settings", module, setting, value)
					es.keygroupsave("soccer_mod_settings", "soccer_mod")

					tokens["name"] = player.name
					tokens["value"] = value
					lang_msg(messages, "set_%s" % (setting), tokens)

					es.keydelete("sm_keygroup_set", player.steamid)
					popuplib.send(name, userid)
				else:
					es.tell(userid, "#green", error)
			else:
				es.tell(userid, "#green", error)
		except ValueError:
			es.tell(userid, "#green", error)
	else:
		es.keydelete("sm_keygroup_set", player.steamid)
		popuplib.send(name, userid)

def set_string(userid, text, file, module, setting, max, name, number):
	messages = langlib.Strings("%sadmin/settings/messages_settings_%s.ini" % (lang_dir, file))
	texts = langlib.Strings("%sadmin/settings/popup_settings_%s.ini" % (lang_dir, file))

	tokens = {}
	player = playerlib.getPlayer(userid)

	text = text.strip('"')

	if text != "!cancel":
		if len(text) <= max:
			es.set("sm_%s_%s" % (module, setting), text)

			popuplib.find(name).modline((number + 2), "->%s. %s: %s" % (number, texts(setting), text))

			es.keysetvalue("soccer_mod_settings", module, setting, text)
			es.keygroupsave("soccer_mod_settings", "soccer_mod")

			tokens["name"] = player.name
			tokens["value"] = text
			lang_msg(messages, "set_%s" % (setting), tokens)

			es.keydelete("sm_keygroup_set", player.steamid)
			popuplib.send(name, userid)
		else:
			tokens["number"] = max
			es.tell(userid, "#green", messages("to_long", tokens, player.get("lang")))
	else:
		es.keydelete("sm_keygroup_set", player.steamid)
		popuplib.send(name, userid)

def lang_msg(messages, text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	es.keygroupdelete("soccer_mod_settings")

	popuplib.delete("sm_popup_admin_settings")

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			es.unload("soccer_mod_2011/admin/settings/%s" % (item))