﻿import es
import langlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "info/popup_info_commands.ini")

modules = ["cap", "match", "shout", "skins", "sprint", "stats", "training", "vote"]

# ******************** Load ********************
def load():
	create_popup()
	create_module_popups()

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_info_commands")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	number = 1

	values = ["info", "admin"]
	for i in range(0, len(values)):
		popup.addline("%s - %s" % (es.ServerVar("sm_command_%s" % (values[i])), popup_text(values[i])))

	popup.addline(" ")

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			popup.addline("->%s. %s" % (number, popup_text(item)))
			popup.submenu(number, "%s_%s" % ("sm_popup_info_commands", item))
			number += 1

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	while number < 9:
		popup.submenu(number, "sm_popup_info_commands")
		number += 1

	popup.submenu(9, "sm_popup_info")

# ******************** Events ********************
def es_map_start(event_var):
	delete_module_popups()
	create_module_popups()

# ******************** Functions ********************
def create_module_popups():
	name = "sm_popup_info_commands"

	if es.ServerVar("sm_module_cap_on") == 1:
		create_popup_module(name + "_cap", ["sm_cap_command_pick", "sm_cap_command_position"], ["pick", "pos"])

	if es.ServerVar("sm_module_match_on") == 1:
		create_popup_module(name + "_match", ["sm_match_command_start", "sm_match_command_pause", "sm_match_command_unpause", "sm_match_command_stop"], ["start", "pause", "unpause", "stop"])

	if es.ServerVar("sm_module_shout_on") == 1:
		create_popup_module(name + "_shout", ["sm_shout_command"], ["shout_command"])

	if es.ServerVar("sm_module_skins_on") == 1:
		create_popup_module(name + "_skins", ["sm_skins_command_gk", "sm_skins_command_personal"], ["gk", "personal"])

	if es.ServerVar("sm_module_sprint_on") == 1:
		create_popup_module(name + "_sprint", ["sm_sprint_command"], ["sprint_command"])

	if es.ServerVar("sm_module_stats_on") == 1:
		create_popup_module(name + "_stats", ["sm_stats_command_stats", "sm_stats_command_stats_clear"], ["stats_menu", "stats_clear"])

	if es.ServerVar("sm_module_training_on") == 1:
		create_popup_module(name + "_training", ["sm_training_command_spawn"], ["spawn"])

	if es.ServerVar("sm_module_vote_on") == 1:
		create_popup_module(name + "_vote", ["sm_vote_command"], ["vote_command"])

def create_popup_module(name, commands, info):
	popup = popuplib.create(name)

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	for i in range(0, len(commands)):
		popup.addline("%s - %s" % (es.ServerVar(commands[i]), popup_text(info[i])))

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	for i in range(1, 9):
		popup.submenu(i, name)

	popup.submenu(9, "sm_popup_info_commands")

def delete_module_popups():
	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			popuplib.delete("sm_popup_info_commands_%s" % (item))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_info_commands")

	delete_module_popups()