﻿import langlib
import popuplib
import usermsg

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "info/popup_info_leagues.ini")

# ******************** Load ********************
def load():
	create_popup_leagues()
	create_popup_leagues_acssl()
	create_popup_leagues_bcssl()
	create_popup_leagues_psl()
	create_popup_leagues_rsl()
	create_popup_leagues_xsl()

# ******************** Create popup ********************
def create_popup_leagues():
	popup = popuplib.create("sm_popup_info_leagues")

	popup.addline(popup_text("title"))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("acssl")))
	popup.addline("->2. %s" % (popup_text("bcssl")))
	popup.addline("->3. %s" % (popup_text("psl")))
	popup.addline("->4. %s" % (popup_text("rsl")))
	popup.addline("->5. %s" % (popup_text("xsl")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.submenu(1, "sm_popup_info_leagues_acssl")
	popup.submenu(2, "sm_popup_info_leagues_bcssl")
	popup.submenu(3, "sm_popup_info_leagues_psl")
	popup.submenu(4, "sm_popup_info_leagues_rsl")
	popup.submenu(5, "sm_popup_info_leagues_xsl")

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_info_leagues")

	popup.submenu(9, "sm_popup_info")

def create_popup_leagues_acssl():
	popup = popuplib.create("sm_popup_info_leagues_acssl")

	popup.addline(popup_text("title_acssl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (popup_text("location"), popup_text("australia")))
	popup.addline("%s: http://www.acssl.com" % (popup_text("website")))
	popup.addline("%s: http://steamcommunity.com/groups/acssl" % (popup_text("public")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, popup_choice)

	for i in range(2, 9):
		popup.submenu(i, "sm_popup_info_leagues_acssl")

	popup.submenu(9, "sm_popup_info_leagues")

def create_popup_leagues_bcssl():
	popup = popuplib.create("sm_popup_info_leagues_bcssl")

	popup.addline(popup_text("title_bcssl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (popup_text("location"), popup_text("brazil")))
	popup.addline("%s: http://bcssl.webs.com" % (popup_text("website")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, popup_choice)

	for i in range(2, 9):
		popup.submenu(i, "sm_popup_info_leagues_bcssl")

	popup.submenu(9, "sm_popup_info_leagues")

def create_popup_leagues_psl():
	popup = popuplib.create("sm_popup_info_leagues_psl")

	popup.addline(popup_text("title_psl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (popup_text("location"), popup_text("north_america")))
	popup.addline("%s: http://www.psl-source.com" % (popup_text("website")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, popup_choice)

	for i in range(2, 9):
		popup.submenu(i, "sm_popup_info_leagues_psl")

	popup.submenu(9, "sm_popup_info_leagues")

def create_popup_leagues_rsl():
	popup = popuplib.create("sm_popup_info_leagues_rsl")

	popup.addline(popup_text("title_rsl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (popup_text("location"), popup_text("russia")))
	popup.addline("%s: http://www.rsleague.ru" % (popup_text("website")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, popup_choice)

	for i in range(2, 9):
		popup.submenu(i, "sm_popup_info_leagues_rsl")

	popup.submenu(9, "sm_popup_info_leagues")

def create_popup_leagues_xsl():
	popup = popuplib.create("sm_popup_info_leagues_xsl")

	popup.addline(popup_text("title_xsl"))
	popup.addline(" ")
	popup.addline("%s: %s" % (popup_text("location"), popup_text("europe")))
	popup.addline("%s: http://www.xsleague.com" % (popup_text("website")))
	popup.addline("%s: http://steamcommunity.com/groups/XSL-P" % (popup_text("public")))
	popup.addline("%s: http://steamcommunity.com/groups/XSL" % (popup_text("staff")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("open")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, popup_choice)

	for i in range(2, 9):
		popup.submenu(i, "sm_popup_info_leagues_xsl")

	popup.submenu(9, "sm_popup_info_leagues")

# ******************** Popup choice ********************
def popup_choice(userid, choice, popupid):
	if popupid == "sm_popup_info_leagues_acssl":
		usermsg.motd(userid, 2, popup_text("acssl"), "http://www.acssl.com")
	elif popupid == "sm_popup_info_leagues_bcssl":
		usermsg.motd(userid, 2, popup_text("bcssl"), "http://bcssl.webs.com")
	elif popupid == "sm_popup_info_leagues_psl":
		usermsg.motd(userid, 2, popup_text("psl"), "http://www.psl-source.com")
	elif popupid == "sm_popup_info_leagues_rsl":
		usermsg.motd(userid, 2, popup_text("rsl"), "http://www.rsleague.ru")
	elif popupid == "sm_popup_info_leagues_xsl":
		usermsg.motd(userid, 2, popup_text("xsl"), "http://www.xsleague.com")

	popuplib.send(popupid, userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_info_leagues")
	popuplib.delete("sm_popup_info_leagues_acssl")
	popuplib.delete("sm_popup_info_leagues_bcssl")
	popuplib.delete("sm_popup_info_leagues_psl")
	popuplib.delete("sm_popup_info_leagues_rsl")
	popuplib.delete("sm_popup_info_leagues_xsl")