﻿import es
import langlib
import popuplib
import usermsg

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "info/popup_info_server.ini")

# ******************** Load ********************
def load():
	create_popup()

# ******************** Events ********************
def es_map_start(event_var):
	popuplib.delete("sm_popup_info_server")
	create_popup()

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_info_server")

	popup.addline(popup_text("title"))
	popup.addline(" ")
	popup.addline("%s: %s" % (popup_text("name"), es.ServerVar("hostname")))
	popup.addline("%s: %s:%s" % (popup_text("ip"), es.ServerVar("ip"), es.ServerVar("hostport")))
	popup.addline("%s: %s" % (popup_text("slots"), es.getmaxplayercount()))

	if int(es.ServerVar("tv_enable")) == 1:
		popup.addline(" ")
		popup.addline("%s: %s" % (popup_text("tv_name"), es.ServerVar("tv_name")))
		popup.addline("%s: %s:%s" % (popup_text("tv_ip"), es.ServerVar("ip"), es.ServerVar("tv_port")))
		popup.addline("%s: %s" % (popup_text("tv_slots"), es.ServerVar("tv_maxclients")))

	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("display")))
	popup.addline("->2. Soccer Mod 2011 %s" % (popup_text("servers")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	popup.select(1, server_info_to_chat)
	popup.select(2, view_website)

	for i in range(3, 9):
		popup.submenu(i, "sm_popup_info_server")

	popup.submenu(9, "sm_popup_info")

# ******************** Popup choice ********************
def server_info_to_chat(userid, choice, popupid):
	es.tell(userid, "#green", "%s: %s" % (popup_text("name"), es.ServerVar("hostname")))
	es.tell(userid, "#green", "%s: %s:%s" % (popup_text("ip"), es.ServerVar("ip"), es.ServerVar("hostport")))

	if int(es.ServerVar("tv_enable")) == 1:
		es.tell(userid, "#green", "%s: %s" % (popup_text("tv_name"), es.ServerVar("tv_name")))
		es.tell(userid, "#green", "%s: %s:%s" % (popup_text("tv_name"), es.ServerVar("ip"), es.ServerVar("tv_port")))

	popuplib.send(popupid, userid)

def view_website(userid, choice, popupid):
	usermsg.motd(userid, 2, "Soccer Mod 2011 %s" % (popup_text("servers")), "http://www.game-monitor.com/search.php?search=soccer_mod_2011_version&type=variable&public=&order=-var")

	popuplib.send(popupid, userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_info_server")