﻿import es
import langlib
import playerlib
import popuplib

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_text = langlib.Strings(lang_dir + "modules/match/messages_match.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/match/popup_match.ini")

# ******************** Load ********************
def load():
	es.set("sm_match_name_t", es.ServerVar("sm_match_default_name_t"))
	es.set("sm_match_name_ct", es.ServerVar("sm_match_default_name_ct"))
	es.set("sm_match_short_name_t", es.ServerVar("sm_match_default_short_name_t"))
	es.set("sm_match_short_name_ct", es.ServerVar("sm_match_default_short_name_ct"))

	create_popup()

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_match_names")

	popup.addline("SOCCER MOD %s" % (popup_text("title_names")))
	popup.addline(" ")
	popup.addline("->1. %s: %s" % (popup_text("name_t"), es.ServerVar("sm_match_default_name_t")))
	popup.addline("->2. %s: %s" % (popup_text("name_ct"), es.ServerVar("sm_match_default_name_ct")))
	popup.addline("->3. %s: %s" % (popup_text("short_name_t"), es.ServerVar("sm_match_default_short_name_t")))
	popup.addline("->4. %s: %s" % (popup_text("short_name_ct"), es.ServerVar("sm_match_default_short_name_ct")))
	popup.addline("->5. %s" % (popup_text("reset_names")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(1, 6):
		popup.select(i, popup_choice)

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_admin_match_names")

	popup.submenu(9, "sm_popup_admin_match")

# ******************** Popup choice ********************
def popup_choice(userid, choice, popupid):
	if choice < 5:
		player = playerlib.getPlayer(userid)

		if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
			es.keycreate("sm_keygroup_set", player.steamid)

		settings = ["name_t", "name_ct", "short_name_t", "short_name_ct"]

		es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "match_%s" % (settings[choice - 1]))
		es.tell(userid, "#green", messages_text("type_%s" % (settings[choice - 1]), None, player.get("lang")))
	else:
		name = es.ServerVar("sm_match_default_name_t")
		es.set("sm_match_name_t", name)

		tokens = {}
		tokens["team"] = name

		popuplib.find("sm_popup_admin_match_names").modline(3, "->1. %s: %s" % (popup_text("name_t"), name))
		popuplib.find("sm_popup_admin_match_score").modline(3, "->1. %s" % (popup_text("add", tokens)))
		popuplib.find("sm_popup_admin_match_score").modline(4, "->2. %s" % (popup_text("remove", tokens)))

		name = es.ServerVar("sm_match_default_name_ct")
		es.set("sm_match_name_ct", name)

		tokens["team"] = name

		popuplib.find("sm_popup_admin_match_names").modline(4, "->2. %s: %s" % (popup_text("name_ct"), name))
		popuplib.find("sm_popup_admin_match_score").modline(5, "->3. %s" % (popup_text("add", tokens)))
		popuplib.find("sm_popup_admin_match_score").modline(6, "->4. %s" % (popup_text("remove", tokens)))

		name = es.ServerVar("sm_match_default_short_name_t")
		popuplib.find("sm_popup_admin_match_names").modline(5, "->3. %s: %s" % (popup_text("short_name_t"), name))
		es.set("sm_match_short_name_t", name)

		name = es.ServerVar("sm_match_default_short_name_ct")
		popuplib.find("sm_popup_admin_match_names").modline(6, "->4. %s: %s" % (popup_text("short_name_ct"), name))
		es.set("sm_match_short_name_ct", name)

		tokens["name"] = es.getplayername(userid)
		lang_msg.tell(messages_text, "reset", tokens)

		popuplib.send("sm_popup_admin_match_names", userid)

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	if es.ServerVar("soccer_mod_allowed") == 1:
		player = playerlib.getPlayer(userid)
		if es.exists("key", "sm_keygroup_set", player.steamid) == 1:
			text = text.strip('"')
			type = es.keygetvalue("sm_keygroup_set", player.steamid, "setting_type")
			if type == "match_name_t":
				set_value(text, player, 25, "name_t", 1)
				return (0, None, 0)
			elif type == "match_name_ct":
				set_value(text, player, 25, "name_ct", 2)
				return (0, None, 0)
			elif type == "match_short_name_t":
				set_value(text, player, 5, "short_name_t", 3)
				return (0, None, 0)
			elif type == "match_short_name_ct":
				set_value(text, player, 5, "short_name_ct", 4)
				return (0, None, 0)
			else:
				return (userid, text, teamonly)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def set_value(text, player, max, type, number):
	if text != "!cancel":
		tokens = {}

		if len(text) <= max:
			es.set("sm_match_%s" % (type), text)

			popuplib.find("sm_popup_admin_match_names").modline((number + 2), "->%s. %s: %s" % (number, popup_text(type), text))

			tokens["team"] = es.ServerVar("sm_match_%s" % (type))

			if number == 1:
				popuplib.find("sm_popup_admin_match_score").modline(3, "->1. %s" % (popup_text("add", tokens)))
				popuplib.find("sm_popup_admin_match_score").modline(4, "->2. %s" % (popup_text("remove", tokens)))

			elif number == 2:
				popuplib.find("sm_popup_admin_match_score").modline(5, "->3. %s" % (popup_text("add", tokens)))
				popuplib.find("sm_popup_admin_match_score").modline(6, "->4. %s" % (popup_text("remove", tokens)))

			tokens["name"] = player.name
			tokens["value"] = text
			lang_msg.tell(messages_text, "set_%s" % (type), tokens)

			es.keydelete("sm_keygroup_set", player.steamid)

			popuplib.send("sm_popup_admin_match_names", player.userid)
		else:
			tokens["number"] = max
			es.tell(player.userid, "#green", messages_text("to_long", tokens, player.get("lang")))
	else:
		es.keydelete("sm_keygroup_set", player.steamid)

		popuplib.send("sm_popup_admin_match_names", player.userid)

# ******************** Unload ********************
def unload():
	es.addons.unregisterSayFilter(filter)

	popuplib.delete("sm_popup_admin_match_names")