﻿import es
import langlib
import playerlib
import popuplib

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_text = langlib.Strings(lang_dir + "modules/match/messages_match.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/match/popup_match.ini")

# ******************** Load ********************
def load():
	create_popup()

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_match_score")

	popup.addline("SOCCER MOD %s" % (popup_text("title_score")))
	popup.addline(" ")

	tokens = {}

	tokens["team"] = es.ServerVar("sm_match_default_name_t")

	popup.addline("->1. %s" % (popup_text("add", tokens)))
	popup.addline("->2. %s" % (popup_text("remove", tokens)))

	tokens["team"] = es.ServerVar("sm_match_default_name_ct")

	popup.addline("->3. %s" % (popup_text("add", tokens)))
	popup.addline("->4. %s" % (popup_text("remove", tokens)))

	popup.addline("->5. %s" % (popup_text("reset_score")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	popup.select(1, add)
	popup.select(2, remove)
	popup.select(3, add)
	popup.select(4, remove)
	popup.select(5, reset)

	for i in range(6, 9):
		popup.submenu(i, "sm_popup_admin_match_score")

	popup.submenu(9, "sm_popup_admin_match")

# ******************** Popup choice ********************
def add(userid, choice, name):
	if choice == 1:
		team = "t"
	elif choice == 3:
		team = "ct"

	score = int(es.ServerVar("sm_match_score_%s" % (team))) + 1
	es.set("sm_match_score_%s" % (team), score)

	es.server.queuecmd("score set #%s %s" % (team, score))

	player = playerlib.getPlayer(userid)

	tokens = {}
	tokens["name"] = player.name
	tokens["team"] = es.ServerVar("sm_match_name_%s" % (team))
	lang_msg.tell(messages_text, "goal_added", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

def remove(userid, choice, name):
	if choice == 2:
		team = "t"
	elif choice == 4:
		team = "ct"

	player = playerlib.getPlayer(userid)

	score = int(es.ServerVar("sm_match_score_%s" % (team)))
	if score > 0:
		score -= 1
		es.set("sm_match_score_%s" % (team), score)

		es.server.queuecmd("score set #%s %s" % (team, score))

		tokens = {}
		tokens["name"] = player.name
		tokens["team"] = es.ServerVar("sm_match_name_%s" % (team))
		lang_msg.tell(messages_text, "goal_removed", tokens)
	else:
		es.tell(userid, "#green", messages_text("already_0", None, player.get("lang")))

	popuplib.send("sm_popup_admin_match_score", userid)

def reset(userid, choice, name):
	es.set("sm_match_score_t", 0)
	es.set("sm_match_score_ct", 0)

	es.server.queuecmd("score set #t 0")
	es.server.queuecmd("score set #ct 0")

	player = playerlib.getPlayer(userid)

	tokens = {}
	tokens["name"] = player.name
	lang_msg.tell(messages_text, "reset", tokens)

	popuplib.send("sm_popup_admin_match_score", userid)

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_match_score")