﻿import es
import gamethread
import langlib
import playerlib
import popuplib
import random

lang_msg = es.import_addon("soccer_mod_2011")

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/referee/messages_referee_punish.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "modules/referee/popup_admin_referee_punish.ini")

hurt_sounds = [
	"vo/npc/barney/ba_ohshit03.wav",
	"vo/npc/barney/ba_pain01.wav",
	"vo/npc/barney/ba_pain02.wav",
	"vo/npc/barney/ba_pain03.wav",
	"vo/npc/barney/ba_pain04.wav",
	"vo/npc/barney/ba_pain05.wav",
	"vo/npc/barney/ba_pain06.wav",
	"vo/npc/barney/ba_pain07.wav",
	"vo/npc/barney/ba_pain08.wav",
	"vo/npc/barney/ba_pain09.wav",
	"vo/npc/barney/ba_pain10.wav",
	"vo/npc/male01/pain01.wav",
	"vo/npc/male01/pain02.wav",
	"vo/npc/male01/pain03.wav",
	"vo/npc/male01/pain04.wav",
	"vo/npc/male01/pain05.wav",
	"vo/npc/male01/pain06.wav",
	"vo/npc/male01/pain07.wav",
	"vo/npc/male01/pain08.wav",
	"vo/npc/male01/pain09.wav",
	"vo/npc/male01/ow01.wav"
]

# ******************** Load ********************
def load():
	create_popup()

	global cheer_leaders
	cheer_leaders = []

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_referee_punish")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")
	popup.addline("->1. %s" % (popup_text("fireworks")))
	popup.addline("->2. %s" % (popup_text("give_dope")))
	popup.addline("->3. %s" % (popup_text("out_breath")))
	popup.addline("->4. %s" % (popup_text("lightning")))
	popup.addline("->5. %s" % (popup_text("cheer_leader")))
	popup.addline("->6. %s" % (popup_text("clear_cheer_leader")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (popup_common("close")))

	for i in range(1, 7):
		popup.select(i, popup_choice)

	for i in range(7, 9):
		popup.submenu(i, "sm_popup_admin_referee_punish")

	popup.submenu(9, "sm_popup_admin_referee")

# ******************** Events ********************
def es_map_start(event_var):
	global cheer_leaders
	cheer_leaders = []

def player_spawn(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		if int(event_var["es_userteam"]) > 1:
			global cheer_leaders
			if event_var["es_steamid"] in cheer_leaders:
				es.server.queuecmd("es_xgive %s player_weaponstrip" % (event_var["userid"]))
				es.server.queuecmd("es_xfire %s player_weaponstrip strip" % (event_var["userid"]))

				es.server.queuecmd("playerset color %s 255 255 255 150" % (event_var["userid"]))

				es.setplayerprop(event_var["userid"], "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_death(event_var):
	if es.ServerVar("soccer_mod_allowed") == 1:
		gamethread.cancelDelayed("sm_referee_punish_%s" % (event_var["userid"]))

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	if es.ServerVar("soccer_mod_allowed") == 1:
		player = playerlib.getPlayer(userid)
		if player.team > 1:
			global cheer_leaders
			if player.steamid in cheer_leaders:
				es.emitsound("player", userid, es.ServerVar("sm_referee_sound_cheer_leader_%s" % (random.randint(1, 3))), 1, 0.5)
				return (0, None, 0)
			else:
				return (userid, text, teamonly)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Popup choice ********************
def popup_choice(userid, choice, popupid):
	player = playerlib.getPlayer(userid)

	if choice < 6:
		popup_name = "sm_popup_%s" % (userid)
		if popuplib.exists(popup_name):
			popuplib.delete(popup_name)

		if len(playerlib.getPlayerList("#alive")) > 0:
			myPopup = popuplib.easymenu(popup_name, None, punish)

			if choice == 1:
				myPopup.settitle(popup_text("fireworks"))
			elif choice == 2:
				myPopup.settitle(popup_text("give_dope"))
			elif choice == 3:
				myPopup.settitle(popup_text("out_breath"))
			elif choice == 4:
				myPopup.settitle(popup_text("lightning"))
			elif choice == 5:
				myPopup.settitle(popup_text("cheer_leader"))

			players = []
			for player in playerlib.getPlayerList("#alive"):
				players.append((player.name, player.userid))
			ordered = sorted(players)

			for player in ordered:
				myPopup.addoption("%s_%s" % (choice, player[1]), player[0])

			myPopup.submenu(10, "sm_popup_admin_referee_punish")

			popuplib.send(popup_name, userid)
		else:
			es.tell(userid, "#green", messages_text("no_punish_dead", None, player.get("lang")))

			popuplib.send("sm_popup_admin_referee_punish", userid)
	else:
		global cheer_leaders
		cheer_leaders = []

		tokens = {}
		tokens["name"] = player.name
		lang_msg.tell(messages_text, "cleared_cheer_leaders", tokens)

		popuplib.send("sm_popup_admin_referee_punish", userid)

# ******************** Easymenu choice ********************
def punish(userid, choice, popupid):
	player = playerlib.getPlayer(userid)

	type_split = choice.split("_")
	targetid = int(type_split[1])

	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	if es.exists("userid", targetid) == 1:
		target = playerlib.getPlayer(targetid)

		if target.isdead == 0:
			tokens = {}
			tokens["name"] = player.name
			tokens["target"] = target.name

			punishment = int(type_split[0])
			if punishment == 1:
				fireworks(target)
				lang_msg.tell(messages_text, "fireworks", tokens)
			elif punishment == 2:
				give_dope(target)
				lang_msg.tell(messages_text, "give_dope", tokens)
			elif punishment == 3:
				out_breath(target)
				lang_msg.tell(messages_text, "out_breath", tokens)
			elif punishment == 4:
				lightning(target)
				lang_msg.tell(messages_text, "lightning", tokens)
			elif punishment == 5:
				global cheer_leaders
				if target.steamid not in cheer_leaders:
					cheer_leader(target)
					lang_msg.tell(messages_text, "cheer_leader", tokens)
				else:
					es.tell(userid, "#green", messages_text("already_cheer_leader", tokens, player.get("lang")))
		else:
			es.tell(userid, "#green", messages_text("no_punish_dead", None, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_common("no_player_found", None, player.get("lang")))

	popuplib.send("sm_popup_admin_referee_punish", userid)

# ******************** Functions ********************
def fireworks(player):
	player_sound(player, es.ServerVar("sm_referee_sound_fireworks"), 1, 0.5)

	player_shake(player, 2, 100)

	player_push(player, 5)
	gamethread.delayedname(0.1, "sm_referee_punish_%s" % (player), player_push, (player, 20))
	gamethread.delayedname(0.2, "sm_referee_punish_%s" % (player), player_push, (player, 45))
	gamethread.delayedname(0.3, "sm_referee_punish_%s" % (player), player_push, (player, 80))
	gamethread.delayedname(0.4, "sm_referee_punish_%s" % (player), player_push, (player, 125))
	gamethread.delayedname(0.5, "sm_referee_punish_%s" % (player), player_push, (player, 180))
	gamethread.delayedname(0.6, "sm_referee_punish_%s" % (player), player_push, (player, 245))
	gamethread.delayedname(0.7, "sm_referee_punish_%s" % (player), player_push, (player, 320))
	gamethread.delayedname(0.8, "sm_referee_punish_%s" % (player), player_push, (player, 405))
	gamethread.delayedname(0.9, "sm_referee_punish_%s" % (player), player_push, (player, 500))
	gamethread.delayedname(1, "sm_referee_punish_%s" % (player), player_push, (player, 605))
	gamethread.delayedname(1.1, "sm_referee_punish_%s" % (player), player_push, (player, 720))
	gamethread.delayedname(1.2, "sm_referee_punish_%s" % (player), player_push, (player, 845))
	gamethread.delayedname(1.3, "sm_referee_punish_%s" % (player), player_push, (player, 980))
	gamethread.delayedname(1.4, "sm_referee_punish_%s" % (player), player_push, (player, 1125))
	gamethread.delayedname(1.5, "sm_referee_punish_%s" % (player), player_push, (player, 1280))
	gamethread.delayedname(1.6, "sm_referee_punish_%s" % (player), player_push, (player, 1445))
	gamethread.delayedname(1.7, "sm_referee_punish_%s" % (player), player_push, (player, 1620))
	gamethread.delayedname(1.8, "sm_referee_punish_%s" % (player), player_push, (player, 1805))
	gamethread.delayedname(1.9, "sm_referee_punish_%s" % (player), player_push, (player, 2000))

	gamethread.delayedname(2.5, "sm_referee_punish_%s" % (player), player_explosion, (player))
	gamethread.delayedname(2.5, "sm_referee_punish_%s" % (player), player_sound, (player, "weapons/hegrenade/explode4.wav", 1, 0.5))
	gamethread.delayedname(2.5, "sm_referee_punish_%s" % (player), player_kill, (player))

def give_dope(player):
	player_sound(player, random.choice(hurt_sounds), 1, 0.5)

	gamethread.delayedname(1.5, "sm_referee_punish_%s" % (player), player_sound, (player, es.ServerVar("sm_referee_sound_give_dope"), 1, 0.5))

	player_shake(player, 1, 100)
	gamethread.delayedname(1.6, "sm_referee_punish_%s" % (player), player_shake, (player, 6.6, 25))

	gamethread.delayedname(1.6, "sm_referee_punish_%s" % (player), player_speed, (player, 1.01))
	gamethread.delayedname(1.7, "sm_referee_punish_%s" % (player), player_speed, (player, 1.02))
	gamethread.delayedname(1.8, "sm_referee_punish_%s" % (player), player_speed, (player, 1.04))
	gamethread.delayedname(2, "sm_referee_punish_%s" % (player), player_speed, (player, 1.08))
	gamethread.delayedname(2.5, "sm_referee_punish_%s" % (player), player_speed, (player, 1.16))
	gamethread.delayedname(3, "sm_referee_punish_%s" % (player), player_speed, (player, 1.32))
	gamethread.delayedname(3.5, "sm_referee_punish_%s" % (player), player_speed, (player, 1.64))
	gamethread.delayedname(4, "sm_referee_punish_%s" % (player), player_speed, (player, 2.28))
	gamethread.delayedname(5, "sm_referee_punish_%s" % (player), player_speed, (player, 4.56))
	gamethread.delayedname(7, "sm_referee_punish_%s" % (player), player_speed, (player, 9.68))

	es.server.queuecmd("usermsg fade %s 1 500 500 255 255 255 200" % (player))

	gamethread.delayedname(2, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(2.2, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(2.4, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(2.6, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(2.8, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(3, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(3.2, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(3.4, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(3.6, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(3.8, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(4, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(4.2, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(4.4, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(4.6, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(4.8, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(5, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(5.2, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(5.4, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(5.6, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(5.8, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(6, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(6.2, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(6.4, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(6.6, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(6.8, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(7, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 100, 100))
	gamethread.delayedname(7.2, "sm_referee_punish_%s" % (player), player_fade, (player, 1, 100, 100))
	gamethread.delayedname(7.4, "sm_referee_punish_%s" % (player), player_fade, (player, 2, 400, 400))

	gamethread.delayedname(8.2, "sm_referee_punish_%s" % (player), player_kill, (player))

def out_breath(player):
	player_sound(player, es.ServerVar("sm_referee_sound_out_breath"), 1, 0.5)

	player_shake(player, 6, 20)

	es.server.queuecmd("usermsg fade %s 2 3000 2000 0 0 0 255" % (player))

	gamethread.delayedname(0.5, "sm_referee_punish_%s" % (player), player_speed, (player, 0.95))
	gamethread.delayedname(1, "sm_referee_punish_%s" % (player), player_speed, (player, 0.9))
	gamethread.delayedname(1.5, "sm_referee_punish_%s" % (player), player_speed, (player, 0.85))
	gamethread.delayedname(2, "sm_referee_punish_%s" % (player), player_speed, (player, 0.8))
	gamethread.delayedname(2.5, "sm_referee_punish_%s" % (player), player_speed, (player, 0.75))
	gamethread.delayedname(3, "sm_referee_punish_%s" % (player), player_speed, (player, 0.7))
	gamethread.delayedname(3.5, "sm_referee_punish_%s" % (player), player_speed, (player, 0.65))
	gamethread.delayedname(4, "sm_referee_punish_%s" % (player), player_speed, (player, 0.6))
	gamethread.delayedname(4.2, "sm_referee_punish_%s" % (player), player_speed, (player, 0.5))
	gamethread.delayedname(4.4, "sm_referee_punish_%s" % (player), player_speed, (player, 0.4))
	gamethread.delayedname(4.6, "sm_referee_punish_%s" % (player), player_speed, (player, 0.3))
	gamethread.delayedname(4.8, "sm_referee_punish_%s" % (player), player_speed, (player, 0.2))
	gamethread.delayedname(5, "sm_referee_punish_%s" % (player), player_speed, (player, 0.175))
	gamethread.delayedname(5.2, "sm_referee_punish_%s" % (player), player_speed, (player, 0.15))
	gamethread.delayedname(5.4, "sm_referee_punish_%s" % (player), player_speed, (player, 0.125))
	gamethread.delayedname(5.6, "sm_referee_punish_%s" % (player), player_speed, (player, 0.1))
	gamethread.delayedname(5.8, "sm_referee_punish_%s" % (player), player_speed, (player, 0.075))
	gamethread.delayedname(6, "sm_referee_punish_%s" % (player), player_speed, (player, 0.05))
	gamethread.delayedname(6.2, "sm_referee_punish_%s" % (player), player_speed, (player, 0.025))

	gamethread.delayedname(6.2, "sm_referee_punish_%s" % (player), player_kill, (player))

def lightning(player):
	player_sound(player, es.ServerVar("sm_referee_sound_lightning"), 1.0, 0.5)

	x,y,z = es.getplayerlocation(player)
	pos1 = "%s,%s,%s" % (x, y, z)
	z += 2000
	pos2 = "%s,%s,%s" % (x, y, z)

	model = es.precachemodel("sprites/lgtning.vmt")

	es.server.queuecmd("es_effect beam %s %s %s %s 0 30 0.1 5 5 0 0 255 255 255 255 100" % (pos1, pos2, model, model))

	pos1 = "%s,%s,%s" % (x, y, z)
	pos2 = "0,0,0"
	es.server.queuecmd("es_xeffect sparks %s 9999 3 %s" % (pos1, pos2))

	gamethread.delayedname(0.1, "sm_referee_punish_%s" % (player), player_kill, (player))

def cheer_leader(player):
	global cheer_leaders
	cheer_leaders.append(player.steamid)

	es.server.queuecmd("es_xgive %s player_weaponstrip" % (player))
	es.server.queuecmd("es_xfire %s player_weaponstrip strip" % (player))

	es.server.queuecmd("playerset color %s 255 255 255 150" % (player))

	es.setplayerprop(player, "CCSPlayer.baseclass.baseclass.baseclass.baseclass.baseclass.baseclass.m_CollisionGroup", 2)

def player_explosion(player):
	if player.isdead == 0:
		x,y,z = es.getplayerlocation(player)
		es.server.queuecmd("es_xeffect sparks %s,%s,%s 9999 3 0,0,0" % (x, y, z))

def player_push(player, push):
	if player.isdead == 0:
		es.setplayerprop(player, "CCSPlayer.baseclass.localdata.m_vecBaseVelocity", "0,0,%s" % (push))

def player_speed(player, speed):
	if player.isdead == 0:
		player.setSpeed(speed)

def player_sound(player, sound, volume, range):
	if player.isdead == 0:
		es.emitsound("player", player, sound, volume, range)

def player_shake(player, time, magnitude):
	if player.isdead == 0:
		es.server.queuecmd("usermsg shake %s %s %s" % (player, magnitude, time))

def player_fade(player, style, time, total):
	if player.isdead == 0:
		es.server.queuecmd("usermsg fade %s %s %s %s %s %s %s %s" % (player, style, time, total, random.randint(0, 255), random.randint(0, 255), random.randint(0, 255), random.randint(100, 255)))

def player_kill(player):
	es.server.insertcmd("es_xsexec %s kill" % (player))

# ******************** Unload ********************
def unload():
	global cheer_leaders
	cheer_leaders = []

	es.addons.unregisterSayFilter(filter)

	popuplib.delete("sm_popup_admin_referee_punish")