﻿import es
import gamethread
import langlib
import playerlib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "modules/sprint/messages_sprint.ini")

used = []

# ******************** Commands ********************
def cmd_sprint():
	player = playerlib.getPlayer(es.getcmduserid())

	if es.ServerVar("soccer_mod_allowed") == 1:
		if player.steamid not in used:
			used.append(player.steamid)

			player.setSpeed(es.ServerVar("sm_sprint_speed"))

			es.tell(player, "#green", messages_text("use", None, player.get("lang")))

			gamethread.delayedname(es.ServerVar("sm_sprint_length"), "sm_sprint", stop, (player))
			gamethread.delayedname(es.ServerVar("sm_sprint_reset"), "sm_sprint", reset, (player))
	else:
		es.tell(player, "#green", messages_common("not_allowed", None, player.get("lang")))

# ******************** Functions ********************
def stop(player):
	if es.exists("userid", player) == 1:
		player.setSpeed(1)
		es.tell(player, "#green", messages_text("end", None, player.get("lang")))

def reset(player):
	used.remove(player.steamid)

	if es.exists("userid", player) == 1:
		es.tell(player, "#green", messages_text("reset", None, player.get("lang")))

# ******************** Unload ********************
def unload():
	gamethread.cancelDelayed("sm_sprint")